// 002 u_c_cgi_basic_object
// 28 dec 2004

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_c_cgi_basic_object;
  interface
  
    type c_basic_object= class
                           m_name: String;

                           destructor Destroy; Override;

                           constructor create_basic_object(p_name: String); Virtual;
                           constructor construct_empty;
                           procedure display_abstract(p_texte: string);
                           procedure check_initialization(p_message: string); virtual;
                 end;

  implementation

    var s_display_constructor, s_display_destructor: boolean;

    constructor c_basic_object.create_basic_object(p_name: String);
      begin
        m_name:= p_name;
        // display_abstract('o_base.initialise');
      end; // create_basic_object

    constructor c_basic_object.construct_empty;
      begin
      end; // construct_empty

    procedure c_basic_object.display_abstract(p_texte: string);
      begin
        // display_bug_halt(m_name+ ' '+ p_texte+ ': abstract procedure');
      end; // display_abstract

    procedure c_basic_object.check_initialization(p_message: string);
        // check that the constructor was called (Delphi: no longer needed)
      begin
        // display(m_name+ ' '+ p_message+ ' is initialized');
      end; // check_initialization

    destructor c_basic_object.Destroy;
      begin
        // not ABSTRACT, since descendents call Inherited
        // display_abstract('c_basic_object.Destroy');
      end; // Destroy

    begin // u_basic_object
    end. // u_basic_object


