// 002 u_cgi_dir
// 28 dec 2004

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_cgi_dir;
  interface

    function f_directory_exists(const p_directory_name: string): Boolean;
    function f_force_directories(p_directory: string): Boolean;
    function f_without_ending_slash(p_string: String): String;

  implementation
    uses Windows, SysUtils
        ;

    function f_directory_exists(const p_directory_name: string): Boolean;
      var // l_code: dword;
          l_code: Integer;
      begin
        // display(p_directory_name);
        // stop('');
        (*$r-*)
        l_code := GetFileAttributes(PChar(p_directory_name));
        Result := (l_code<> -1)
                 and
                  ((FILE_ATTRIBUTE_DIRECTORY and l_code)<> 0);
        (*$r+*)
      end; // f_directory_exists

    function f_force_directories(p_directory: string): Boolean;
      begin
        Result := True;
        // if Length(Dir) = 0
        //  then
        //    raise Exception.CreateRes(@SCannotCreateDir);
        p_directory:= ExcludeTrailingBackslash(p_directory);
        if (Length(p_directory) < 3) or f_directory_exists(p_directory)
            or (ExtractFilePath(p_directory) = p_directory)
          then Exit; // avoid 'xyz:\' problem.
        Result := f_force_directories(ExtractFilePath(p_directory))
            and CreateDir(p_directory);
      end; // f_force_directories

    function f_without_ending_slash(p_string: String): String;
      var l_length, l_index: Integer;
      begin
        l_length:= Length(Trim(p_string));
        if l_length= 0
          then Result:= ''
          else begin
              Result:= p_string;

              // remove all ending \
              l_index:= l_length;
              while (l_index> 1) and (Result[l_index]= '\') do
                dec(l_index);
              SetLength(Result, l_index);
            end;
      end; // f_without_ending_slash

    begin // u_dir
    end. // u_dir







